﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net.Http;
using System.Net.Http.Headers;
using Newtonsoft.Json.Linq;
using System.Diagnostics;
using System.IO;

namespace esl
{
    class DocumentVisibilityREST
    {
        public static void main()
        {
            string apiKey = "api_key";
            string url = "https://sandbox.esignlive.com/api";

            string jsonString = "{\"autocomplete\":true,\"description\":\"This is a package created using the eSignLive REST API\",\"documents\":[{\"approvals\":[{\"fields\":[{\"extract\":false,\"height\":50,\"left\":100,\"page\":0,\"subtype\":\"FULLNAME\",\"top\":100,\"type\":\"SIGNATURE\",\"width\":200}],\"role\":\"Signer1\"}],\"extract\":false,\"fields\":[],\"id\":\"doc1\",\"index\":0,\"name\":\"Document1\",\"pages\":[]},{\"approvals\":[{\"fields\":[{\"extract\":false,\"height\":50,\"left\":100,\"page\":0,\"subtype\":\"FULLNAME\",\"top\":100,\"type\":\"SIGNATURE\",\"width\":200}],\"role\":\"Signer2\"}],\"extract\":false,\"fields\":[],\"id\":\"doc2\",\"index\":0,\"name\":\"Document2\",\"pages\":[]}],\"name\":\"DocumentVisibilityExample 3/6/2017 12:38:40 PM\",\"roles\":[{\"id\":\"Signer1\",\"index\":0,\"name\":\"Signer1\",\"signers\":[{\"email\":\"mail31@mailinator.com\",\"firstName\":\"John1\",\"id\":\"Signer1\",\"lastName\":\"Smith1\"}]},{\"id\":\"Signer2\",\"index\":0,\"name\":\"Signer2\",\"signers\":[{\"email\":\"mail32@mailinator.com\",\"firstName\":\"John2\",\"id\":\"Signer2\",\"lastName\":\"Smith2\"}]}],\"type\":\"PACKAGE\",\"visibility\":\"ACCOUNT\"}";

            StringContent jsonContent = new StringContent(jsonString, Encoding.UTF8, "application/json");

            byte[] fileByteArray1 = File.ReadAllBytes(@"C:/Users/hhaidary/Desktop/PDFs/cleaning_contract.pdf");
            ByteArrayContent content1 = new ByteArrayContent(fileByteArray1);

            content1.Headers.ContentDisposition = new ContentDispositionHeaderValue("form-data");
            content1.Headers.ContentDisposition.Name = "\"file\"";
            content1.Headers.ContentDisposition.FileName = "\"cleaning_contract.pdf\"";
            content1.Headers.ContentType = new MediaTypeHeaderValue("application/pdf");

            byte[] fileByteArray2 = File.ReadAllBytes(@"C:/Users/hhaidary/Desktop/PDFs/sample_contract.pdf");
            ByteArrayContent content2 = new ByteArrayContent(fileByteArray1);

            content2.Headers.ContentDisposition = new ContentDispositionHeaderValue("form-data");
            content2.Headers.ContentDisposition.Name = "\"file\"";
            content2.Headers.ContentDisposition.FileName = "\"sample_contract.pdf\"";
            content2.Headers.ContentType = new MediaTypeHeaderValue("application/pdf");

            MultipartFormDataContent form = new MultipartFormDataContent();
            form.Add(content1, "\"file\"", "\"cleaning_contract.pdf\"");
            form.Add(content2, "\"file\"", "\"sample_contract.pdf\"");
            form.Add(jsonContent, "\"payload\"");

            HttpClient myClient = new HttpClient();
            myClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", apiKey);
            myClient.DefaultRequestHeaders.Add("Accept", "application/json");

            var response = myClient.PostAsync(new Uri(url) + "/packages/", form).Result;
            JObject jsonResponse = JObject.Parse(response.Content.ReadAsStringAsync().Result);
            Debug.WriteLine(jsonResponse["id"]);

            //Set Document Visibility Configuration
            string jsonString2 = "{\"configurations\":[{\"documentUid\":\"doc1\",\"roleUids\":[\"Signer1\"]},{\"documentUid\":\"doc2\",\"roleUids\":[\"Signer2\"]}]}";

            StringContent jsonContent2 = new StringContent(jsonString2, Encoding.UTF8, "application/json");

            response = myClient.PostAsync(new Uri(url) + "/packages/" + jsonResponse["id"] + "/documents/visibility", jsonContent2).Result;

            //Send package
            string jsonString3 = "{\"status\": \"SENT\"}";
            StringContent jsonContent3 = new StringContent(jsonString3, Encoding.UTF8, "application/json");

            response = myClient.PostAsync(new Uri(url) + "/packages/" + jsonResponse["id"], jsonContent3).Result;

        }
    }
}
